/*
* Copyright 2019 NXP
* SPDX-License-Identifier: BSD-3-Clause
*/
 
#ifndef _MC_STATEMACHINE_H_
#define _MC_STATEMACHINE_H_

/******************************************************************************
* Includes
******************************************************************************/
#include "fsl_common.h"
/* library headers */
#include "gmclib.h"
#include "gflib.h"
#include "gdflib.h"
#include "amclib.h"

/* application constants */
#include "PMSM_SpeedVectorCtrl.h"
#include "state_machine.h"
#include "motor_structure.h"


/******************************************************************************
* Constants
******************************************************************************/

/******************************************************************************
* Macros 
******************************************************************************/

/******************************************************************************
* Types
******************************************************************************/

/******************************************************************************
* Global variables
******************************************************************************/
extern SM_APP_CTRL_T 					gsMC_Ctrl;
extern MCSTRUC_FOC_PMSM_OBS_DQ_T		gsMC_Drive;
extern MCSTRUC_ADC_2_PHASE_ASSIGNMENT_T gsMC_IChannels;
extern GMCLIB_2COOR_AB_T_F16 				gsMC_I;
extern GMCLIB_2COOR_AB_T_F16 				gsMC_IOffset;
extern MCSTRUC_CONTROL_LOOP_T 			geMC_StateRunLoop;

extern MCSTRUC_FAULT_RECORD_T 			faultRecordFlag;

extern uint16_t 							uw16WaitForWakeUpFlag;
extern uint16_t 							uw16DelayEnterStopCntr;

/******************************************************************************
* Global functions
******************************************************************************/

extern void MC_Fault(void);

/******************************************************************************
* Inline functions
******************************************************************************/

#endif /* _MC_STATEMACHINE_H_ */

