/*
* Copyright 2019 NXP
* SPDX-License-Identifier: BSD-3-Clause
*/

#ifndef BUTTON_H_
#define BUTTON_H_
#include <peripherals_manual.h>
#include "fsl_common.h"

//typedef uint16_t (*func_ptr)(button_ctrl* ptr);

typedef enum
{
	NOT_PRESSED = 0,
	PRESSED_BEFORE_DEBOUNCE = 1,
	PRESSED_AFTER_DEBOUNCE = 2,
	WAIT_FOR_RELEASE = 3,
	RELEASED_BEFORE_DEBOUNCE = 4,
	RELEASED_AFTER_DEBOUNCE = 5
} BUTTON_STATUS;

typedef struct button_ctrl BUTTON_CTRL_TYPE;
struct button_ctrl
{
	volatile uint16_t u16Cnt;  // The counter for key debounce
	BUTTON_STATUS sStatus;
	uint16_t (*readButtonVal)(BUTTON_CTRL_TYPE* ptr);
	uint16_t (*check_button)(BUTTON_CTRL_TYPE *ptr);
	void (*debounce)(BUTTON_CTRL_TYPE *ptr);
};

#define DEBOUNCE_CNT 100

extern uint16_t readSWButton(BUTTON_CTRL_TYPE *ptr);
extern uint16_t is_button_pressed(BUTTON_CTRL_TYPE *ptr);
extern void button_process(BUTTON_CTRL_TYPE *ptr);

#endif /* BUTTON_H_ */
