/*
* Copyright 2019 NXP
* SPDX-License-Identifier: BSD-3-Clause
*/
 
#ifndef _HWCONTROL_H_
#define _HWCONTROL_H_
#include "gmclib.h"
#include "PMSM_SpeedVectorCtrl.h"
#include "fsl_device_registers.h"

/* Constant definition*/
#define PWMA_SM012_RUN() PWM1->MCTRL |= PWM_MCTRL_RUN(0x07)

#define MC_DISABLE_PWM_OUTPUT() PWM1->OUTEN &= ~(PWM_OUTEN_PWMA_EN(0x7)|PWM_OUTEN_PWMB_EN(0x7))
#define MC_ENABLE_PWM_OUTPUT() PWM1->OUTEN |= (PWM_OUTEN_PWMA_EN(0x7)|PWM_OUTEN_PWMB_EN(0x7))
#define MC_OVERCURRENT_FAULT() (PWM1->FSTS & PWM_FSTS_FFLAG(1))
#define MC_CLEAR_OVERCURRENT_FAULT() PWM1->FSTS |= PWM_FSTS_FFLAG(1)




/*MR20141208_C*/
//#define DISABLE_WATCHDOG()                      ( COP->CTRL &= ~(0x0002|0x0008) )
//#define ENABLE_WATCHDOG()                       ( COP->CTRL |= 0x0002 )
//#define KICK_THE_WATCHDOG()                     do{ COP->CNTR = 0x5555; COP->CNTR = 0xAAAA; }while(0)


static inline void MC_PWM_UPDATE(GMCLIB_3COOR_T_F16 *psDuty)
{
	int16_t w16ModuloHalf = PWM1->SM[0].VAL1;
	int16_t w16Result;
	
	/* PWM channels 0&1  */ 
	w16Result = MLIB_MulRnd_F16(psDuty->f16A, w16ModuloHalf);

	PWM1->SM[0].VAL2 = -w16Result;
	PWM1->SM[0].VAL3 = w16Result;

	/* PWM channels 2&3 */								 
	w16Result = MLIB_MulRnd_F16(psDuty->f16B, w16ModuloHalf);
	
	PWM1->SM[1].VAL2 = -w16Result;
	PWM1->SM[1].VAL3 = w16Result;
														 
	/* PWM channels 4&5 */								 
	w16Result = MLIB_MulRnd_F16(psDuty->f16C, w16ModuloHalf);

	PWM1->SM[2].VAL2 = -w16Result;
	PWM1->SM[2].VAL3 = w16Result;
														 
	/* load new values to PWM registers */				 
	//PWMA_MCTRL |= PWM_MCTRL_LDOK(1) | PWM_MCTRL_LDOK(2) | PWM_MCTRL_LDOK(4); /* LDOK */ 
	PWM1->MCTRL |= PWM_MCTRL_LDOK(0x7); /* LDOK */
	
}

#endif /* _HWCONTROL_H_ */

